import{s as _a,n as Ca,o as La}from"../chunks/scheduler.c59d9fbb.js";import{S as Ea,i as ka,g as a,s as i,r as p,A as Ma,h as d,f as e,c as s,j as h,u,x as f,k as o,y as l,a as n,v as c,d as g,t as m,w as v}from"../chunks/index.a47918e3.js";import{I as w}from"../chunks/IconCopyLink.1678bef0.js";function Sa(Me){let x,It,T,M,$t,j,Te,ct,Se="PEFT",Gt,z,He=`🤗 PEFT, or Parameter-Efficient Fine-Tuning (PEFT), is a library for efficiently adapting pre-trained language models (PLMs) to various downstream applications without fine-tuning all the model’s parameters.
PEFT methods only fine-tune a small number of (extra) model parameters, significantly decreasing computational and storage costs because fine-tuning large-scale PLMs is prohibitively costly.
Recent state-of-the-art PEFT techniques achieve performance comparable to that of full fine-tuning.`,Bt,J,Ne='PEFT is seamlessly integrated with 🤗 Accelerate for large-scale models leveraging DeepSpeed and <a href="https://huggingface.co/docs/accelerate/usage_guides/big_modeling" rel="nofollow">Big Model Inference</a>.',Ft,S,Re='<div class="w-full flex flex-col space-y-4 md:space-y-0 md:grid md:grid-cols-2 md:gap-y-4 md:gap-x-5"><a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="quicktour"><div class="w-full text-center bg-gradient-to-br from-blue-400 to-blue-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Get started</div> <p class="text-gray-700">Start here if you&#39;re new to 🤗 PEFT to get an overview of the library&#39;s main features, and how to train a model with a PEFT method.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./task_guides/image_classification_lora"><div class="w-full text-center bg-gradient-to-br from-indigo-400 to-indigo-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">How-to guides</div> <p class="text-gray-700">Practical guides demonstrating how to apply various PEFT methods across different types of tasks like image classification, causal language modeling, automatic speech recognition, and more. Learn how to use 🤗 PEFT with the DeepSpeed and Fully Sharded Data Parallel scripts.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./conceptual_guides/lora"><div class="w-full text-center bg-gradient-to-br from-pink-400 to-pink-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Conceptual guides</div> <p class="text-gray-700">Get a better theoretical understanding of how LoRA and various soft prompting methods help reduce the number of trainable parameters to make training more efficient.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./package_reference/config"><div class="w-full text-center bg-gradient-to-br from-purple-400 to-purple-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Reference</div> <p class="text-gray-700">Technical descriptions of how 🤗 PEFT classes and methods work.</p></a></div>',qt,b,H,_t,U,be,gt,Ie="Supported methods",Dt,V,Ge='<li>LoRA: <a href="https://arxiv.org/pdf/2106.09685.pdf" rel="nofollow">LORA: LOW-RANK ADAPTATION OF LARGE LANGUAGE MODELS</a></li> <li>Prefix Tuning: <a href="https://aclanthology.org/2021.acl-long.353/" rel="nofollow">Prefix-Tuning: Optimizing Continuous Prompts for Generation</a>, <a href="https://arxiv.org/pdf/2110.07602.pdf" rel="nofollow">P-Tuning v2: Prompt Tuning Can Be Comparable to Fine-tuning Universally Across Scales and Tasks</a></li> <li>P-Tuning: <a href="https://arxiv.org/pdf/2103.10385.pdf" rel="nofollow">GPT Understands, Too</a></li> <li>Prompt Tuning: <a href="https://arxiv.org/pdf/2104.08691.pdf" rel="nofollow">The Power of Scale for Parameter-Efficient Prompt Tuning</a></li> <li>AdaLoRA: <a href="https://arxiv.org/abs/2303.10512" rel="nofollow">Adaptive Budget Allocation for Parameter-Efficient Fine-Tuning</a></li> <li><a href="https://github.com/ZrrSkywalker/LLaMA-Adapter" rel="nofollow">LLaMA-Adapter: Efficient Fine-tuning of Language Models with Zero-init Attention</a></li> <li>IA3: <a href="https://arxiv.org/abs/2205.05638" rel="nofollow">Infused Adapter by Inhibiting and Amplifying Inner Activations</a></li>',Ot,y,N,Ct,W,ye,mt,Be="Supported models",jt,Z,Fe=`The tables provided below list the PEFT methods and models supported for each task. To apply a particular PEFT method for
a task, please refer to the corresponding Task guides.`,zt,P,R,Lt,K,Pe,vt,qe="Causal Language Modeling",Jt,X,De="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-NeoX-20B</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>LLaMA</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>ChatGLM</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr></tbody>",Ut,A,I,Et,Q,Ae,wt,Oe="Conditional Generation",Vt,Y,je="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>T5</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>BART</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr></tbody>",Wt,$,G,kt,tt,$e,xt,ze="Sequence Classification",Zt,et,Je="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>BERT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>RoBERTa</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Deberta</td> <td>✅</td> <td></td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Deberta-v2</td> <td>✅</td> <td></td> <td>✅</td> <td>✅</td> <td></td></tr></tbody>",Kt,_,B,Mt,at,_e,Tt,Ue="Token Classification",Xt,dt,Ve="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>BERT</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>RoBERTa</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>Deberta</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr> <tr><td>Deberta-v2</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",Qt,C,F,St,rt,Ce,bt,We="Text-to-Image Generation",Yt,nt,Ze="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>Stable Diffusion</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",te,L,q,Ht,ot,Le,yt,Ke="Image Classification",ee,lt,Xe="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th> <th></th></tr></thead> <tbody><tr><td>ViT</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td> <td></td></tr> <tr><td>Swin</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ae,E,D,Nt,it,Ee,Pt,Qe="Image to text (Multi-modal models)",de,st,Ye=`We have tested LoRA for <a href="https://huggingface.co/docs/transformers/model_doc/vit" rel="nofollow">ViT</a> and <a href="https://huggingface.co/docs/transformers/model_doc/swin" rel="nofollow">Swin</a> for fine-tuning on image classification.
However, it should be possible to use LoRA for any <a href="https://huggingface.co/models?pipeline_tag=image-classification&amp;sort=downloads&amp;search=vit" rel="nofollow">ViT-based model</a> from 🤗 Transformers.
Check out the <a href="/task_guides/image_classification_lora">Image classification</a> task guide to learn more. If you run into problems, please open an issue.`,re,ht,ta="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>Blip-2</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ne,k,O,Rt,ft,ke,At,ea="Semantic Segmentation",oe,pt,aa=`As with image-to-text models, you should be able to apply LoRA to any of the <a href="https://huggingface.co/models?pipeline_tag=image-segmentation&amp;sort=downloads" rel="nofollow">segmentation models</a>.
It’s worth noting that we haven’t tested this with every architecture yet. Therefore, if you come across any issues, kindly create an issue report.`,le,ut,da="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>SegFormer</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ie;return j=new w({}),U=new w({}),W=new w({}),K=new w({}),Q=new w({}),tt=new w({}),at=new w({}),rt=new w({}),ot=new w({}),it=new w({}),ft=new w({}),{c(){x=a("meta"),It=i(),T=a("h1"),M=a("a"),$t=a("span"),p(j.$$.fragment),Te=i(),ct=a("span"),ct.textContent=Se,Gt=i(),z=a("p"),z.textContent=He,Bt=i(),J=a("p"),J.innerHTML=Ne,Ft=i(),S=a("div"),S.innerHTML=Re,qt=i(),b=a("h2"),H=a("a"),_t=a("span"),p(U.$$.fragment),be=i(),gt=a("span"),gt.textContent=Ie,Dt=i(),V=a("ol"),V.innerHTML=Ge,Ot=i(),y=a("h2"),N=a("a"),Ct=a("span"),p(W.$$.fragment),ye=i(),mt=a("span"),mt.textContent=Be,jt=i(),Z=a("p"),Z.textContent=Fe,zt=i(),P=a("h3"),R=a("a"),Lt=a("span"),p(K.$$.fragment),Pe=i(),vt=a("span"),vt.textContent=qe,Jt=i(),X=a("table"),X.innerHTML=De,Ut=i(),A=a("h3"),I=a("a"),Et=a("span"),p(Q.$$.fragment),Ae=i(),wt=a("span"),wt.textContent=Oe,Vt=i(),Y=a("table"),Y.innerHTML=je,Wt=i(),$=a("h3"),G=a("a"),kt=a("span"),p(tt.$$.fragment),$e=i(),xt=a("span"),xt.textContent=ze,Zt=i(),et=a("table"),et.innerHTML=Je,Kt=i(),_=a("h3"),B=a("a"),Mt=a("span"),p(at.$$.fragment),_e=i(),Tt=a("span"),Tt.textContent=Ue,Xt=i(),dt=a("table"),dt.innerHTML=Ve,Qt=i(),C=a("h3"),F=a("a"),St=a("span"),p(rt.$$.fragment),Ce=i(),bt=a("span"),bt.textContent=We,Yt=i(),nt=a("table"),nt.innerHTML=Ze,te=i(),L=a("h3"),q=a("a"),Ht=a("span"),p(ot.$$.fragment),Le=i(),yt=a("span"),yt.textContent=Ke,ee=i(),lt=a("table"),lt.innerHTML=Xe,ae=i(),E=a("h3"),D=a("a"),Nt=a("span"),p(it.$$.fragment),Ee=i(),Pt=a("span"),Pt.textContent=Qe,de=i(),st=a("p"),st.innerHTML=Ye,re=i(),ht=a("table"),ht.innerHTML=ta,ne=i(),k=a("h3"),O=a("a"),Rt=a("span"),p(ft.$$.fragment),ke=i(),At=a("span"),At.textContent=ea,oe=i(),pt=a("p"),pt.innerHTML=aa,le=i(),ut=a("table"),ut.innerHTML=da,this.h()},l(t){const r=Ma("svelte-1phssyn",document.head);x=d(r,"META",{name:!0,content:!0}),r.forEach(e),It=s(t),T=d(t,"H1",{class:!0});var se=h(T);M=d(se,"A",{id:!0,class:!0,href:!0});var ra=h(M);$t=d(ra,"SPAN",{});var na=h($t);u(j.$$.fragment,na),na.forEach(e),ra.forEach(e),Te=s(se),ct=d(se,"SPAN",{"data-svelte-h":!0}),f(ct)!=="svelte-hzi8qe"&&(ct.textContent=Se),se.forEach(e),Gt=s(t),z=d(t,"P",{"data-svelte-h":!0}),f(z)!=="svelte-1xarjzd"&&(z.textContent=He),Bt=s(t),J=d(t,"P",{"data-svelte-h":!0}),f(J)!=="svelte-ouajxs"&&(J.innerHTML=Ne),Ft=s(t),S=d(t,"DIV",{class:!0,"data-svelte-h":!0}),f(S)!=="svelte-1ju3glm"&&(S.innerHTML=Re),qt=s(t),b=d(t,"H2",{class:!0});var he=h(b);H=d(he,"A",{id:!0,class:!0,href:!0});var oa=h(H);_t=d(oa,"SPAN",{});var la=h(_t);u(U.$$.fragment,la),la.forEach(e),oa.forEach(e),be=s(he),gt=d(he,"SPAN",{"data-svelte-h":!0}),f(gt)!=="svelte-psanvj"&&(gt.textContent=Ie),he.forEach(e),Dt=s(t),V=d(t,"OL",{"data-svelte-h":!0}),f(V)!=="svelte-1m7g6zz"&&(V.innerHTML=Ge),Ot=s(t),y=d(t,"H2",{class:!0});var fe=h(y);N=d(fe,"A",{id:!0,class:!0,href:!0});var ia=h(N);Ct=d(ia,"SPAN",{});var sa=h(Ct);u(W.$$.fragment,sa),sa.forEach(e),ia.forEach(e),ye=s(fe),mt=d(fe,"SPAN",{"data-svelte-h":!0}),f(mt)!=="svelte-66q3fd"&&(mt.textContent=Be),fe.forEach(e),jt=s(t),Z=d(t,"P",{"data-svelte-h":!0}),f(Z)!=="svelte-1c93f6z"&&(Z.textContent=Fe),zt=s(t),P=d(t,"H3",{class:!0});var pe=h(P);R=d(pe,"A",{id:!0,class:!0,href:!0});var ha=h(R);Lt=d(ha,"SPAN",{});var fa=h(Lt);u(K.$$.fragment,fa),fa.forEach(e),ha.forEach(e),Pe=s(pe),vt=d(pe,"SPAN",{"data-svelte-h":!0}),f(vt)!=="svelte-1lgota1"&&(vt.textContent=qe),pe.forEach(e),Jt=s(t),X=d(t,"TABLE",{"data-svelte-h":!0}),f(X)!=="svelte-trn6pz"&&(X.innerHTML=De),Ut=s(t),A=d(t,"H3",{class:!0});var ue=h(A);I=d(ue,"A",{id:!0,class:!0,href:!0});var pa=h(I);Et=d(pa,"SPAN",{});var ua=h(Et);u(Q.$$.fragment,ua),ua.forEach(e),pa.forEach(e),Ae=s(ue),wt=d(ue,"SPAN",{"data-svelte-h":!0}),f(wt)!=="svelte-kk17vv"&&(wt.textContent=Oe),ue.forEach(e),Vt=s(t),Y=d(t,"TABLE",{"data-svelte-h":!0}),f(Y)!=="svelte-6w2sxz"&&(Y.innerHTML=je),Wt=s(t),$=d(t,"H3",{class:!0});var ce=h($);G=d(ce,"A",{id:!0,class:!0,href:!0});var ca=h(G);kt=d(ca,"SPAN",{});var ga=h(kt);u(tt.$$.fragment,ga),ga.forEach(e),ca.forEach(e),$e=s(ce),xt=d(ce,"SPAN",{"data-svelte-h":!0}),f(xt)!=="svelte-19r8j9g"&&(xt.textContent=ze),ce.forEach(e),Zt=s(t),et=d(t,"TABLE",{"data-svelte-h":!0}),f(et)!=="svelte-jb5iad"&&(et.innerHTML=Je),Kt=s(t),_=d(t,"H3",{class:!0});var ge=h(_);B=d(ge,"A",{id:!0,class:!0,href:!0});var ma=h(B);Mt=d(ma,"SPAN",{});var va=h(Mt);u(at.$$.fragment,va),va.forEach(e),ma.forEach(e),_e=s(ge),Tt=d(ge,"SPAN",{"data-svelte-h":!0}),f(Tt)!=="svelte-n0st7k"&&(Tt.textContent=Ue),ge.forEach(e),Xt=s(t),dt=d(t,"TABLE",{"data-svelte-h":!0}),f(dt)!=="svelte-8nh2hv"&&(dt.innerHTML=Ve),Qt=s(t),C=d(t,"H3",{class:!0});var me=h(C);F=d(me,"A",{id:!0,class:!0,href:!0});var wa=h(F);St=d(wa,"SPAN",{});var xa=h(St);u(rt.$$.fragment,xa),xa.forEach(e),wa.forEach(e),Ce=s(me),bt=d(me,"SPAN",{"data-svelte-h":!0}),f(bt)!=="svelte-18cls7s"&&(bt.textContent=We),me.forEach(e),Yt=s(t),nt=d(t,"TABLE",{"data-svelte-h":!0}),f(nt)!=="svelte-1ert2bf"&&(nt.innerHTML=Ze),te=s(t),L=d(t,"H3",{class:!0});var ve=h(L);q=d(ve,"A",{id:!0,class:!0,href:!0});var Ta=h(q);Ht=d(Ta,"SPAN",{});var ba=h(Ht);u(ot.$$.fragment,ba),ba.forEach(e),Ta.forEach(e),Le=s(ve),yt=d(ve,"SPAN",{"data-svelte-h":!0}),f(yt)!=="svelte-1ifcwhk"&&(yt.textContent=Ke),ve.forEach(e),ee=s(t),lt=d(t,"TABLE",{"data-svelte-h":!0}),f(lt)!=="svelte-13cqscq"&&(lt.innerHTML=Xe),ae=s(t),E=d(t,"H3",{class:!0});var we=h(E);D=d(we,"A",{id:!0,class:!0,href:!0});var ya=h(D);Nt=d(ya,"SPAN",{});var Pa=h(Nt);u(it.$$.fragment,Pa),Pa.forEach(e),ya.forEach(e),Ee=s(we),Pt=d(we,"SPAN",{"data-svelte-h":!0}),f(Pt)!=="svelte-1yforrs"&&(Pt.textContent=Qe),we.forEach(e),de=s(t),st=d(t,"P",{"data-svelte-h":!0}),f(st)!=="svelte-w4w7ox"&&(st.innerHTML=Ye),re=s(t),ht=d(t,"TABLE",{"data-svelte-h":!0}),f(ht)!=="svelte-3x98tj"&&(ht.innerHTML=ta),ne=s(t),k=d(t,"H3",{class:!0});var xe=h(k);O=d(xe,"A",{id:!0,class:!0,href:!0});var Aa=h(O);Rt=d(Aa,"SPAN",{});var $a=h(Rt);u(ft.$$.fragment,$a),$a.forEach(e),Aa.forEach(e),ke=s(xe),At=d(xe,"SPAN",{"data-svelte-h":!0}),f(At)!=="svelte-11uebt1"&&(At.textContent=ea),xe.forEach(e),oe=s(t),pt=d(t,"P",{"data-svelte-h":!0}),f(pt)!=="svelte-179ftdd"&&(pt.innerHTML=aa),le=s(t),ut=d(t,"TABLE",{"data-svelte-h":!0}),f(ut)!=="svelte-jb5pa9"&&(ut.innerHTML=da),this.h()},h(){o(x,"name","hf:doc:metadata"),o(x,"content",JSON.stringify(Ha)),o(M,"id","peft"),o(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(M,"href","#peft"),o(T,"class","relative group"),o(S,"class","mt-10"),o(H,"id","supported-methods"),o(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(H,"href","#supported-methods"),o(b,"class","relative group"),o(N,"id","supported-models"),o(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(N,"href","#supported-models"),o(y,"class","relative group"),o(R,"id","causal-language-modeling"),o(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(R,"href","#causal-language-modeling"),o(P,"class","relative group"),o(I,"id","conditional-generation"),o(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(I,"href","#conditional-generation"),o(A,"class","relative group"),o(G,"id","sequence-classification"),o(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(G,"href","#sequence-classification"),o($,"class","relative group"),o(B,"id","token-classification"),o(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(B,"href","#token-classification"),o(_,"class","relative group"),o(F,"id","texttoimage-generation"),o(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(F,"href","#texttoimage-generation"),o(C,"class","relative group"),o(q,"id","image-classification"),o(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(q,"href","#image-classification"),o(L,"class","relative group"),o(D,"id","image-to-text-multimodal-models"),o(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(D,"href","#image-to-text-multimodal-models"),o(E,"class","relative group"),o(O,"id","semantic-segmentation"),o(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(O,"href","#semantic-segmentation"),o(k,"class","relative group")},m(t,r){l(document.head,x),n(t,It,r),n(t,T,r),l(T,M),l(M,$t),c(j,$t,null),l(T,Te),l(T,ct),n(t,Gt,r),n(t,z,r),n(t,Bt,r),n(t,J,r),n(t,Ft,r),n(t,S,r),n(t,qt,r),n(t,b,r),l(b,H),l(H,_t),c(U,_t,null),l(b,be),l(b,gt),n(t,Dt,r),n(t,V,r),n(t,Ot,r),n(t,y,r),l(y,N),l(N,Ct),c(W,Ct,null),l(y,ye),l(y,mt),n(t,jt,r),n(t,Z,r),n(t,zt,r),n(t,P,r),l(P,R),l(R,Lt),c(K,Lt,null),l(P,Pe),l(P,vt),n(t,Jt,r),n(t,X,r),n(t,Ut,r),n(t,A,r),l(A,I),l(I,Et),c(Q,Et,null),l(A,Ae),l(A,wt),n(t,Vt,r),n(t,Y,r),n(t,Wt,r),n(t,$,r),l($,G),l(G,kt),c(tt,kt,null),l($,$e),l($,xt),n(t,Zt,r),n(t,et,r),n(t,Kt,r),n(t,_,r),l(_,B),l(B,Mt),c(at,Mt,null),l(_,_e),l(_,Tt),n(t,Xt,r),n(t,dt,r),n(t,Qt,r),n(t,C,r),l(C,F),l(F,St),c(rt,St,null),l(C,Ce),l(C,bt),n(t,Yt,r),n(t,nt,r),n(t,te,r),n(t,L,r),l(L,q),l(q,Ht),c(ot,Ht,null),l(L,Le),l(L,yt),n(t,ee,r),n(t,lt,r),n(t,ae,r),n(t,E,r),l(E,D),l(D,Nt),c(it,Nt,null),l(E,Ee),l(E,Pt),n(t,de,r),n(t,st,r),n(t,re,r),n(t,ht,r),n(t,ne,r),n(t,k,r),l(k,O),l(O,Rt),c(ft,Rt,null),l(k,ke),l(k,At),n(t,oe,r),n(t,pt,r),n(t,le,r),n(t,ut,r),ie=!0},p:Ca,i(t){ie||(g(j.$$.fragment,t),g(U.$$.fragment,t),g(W.$$.fragment,t),g(K.$$.fragment,t),g(Q.$$.fragment,t),g(tt.$$.fragment,t),g(at.$$.fragment,t),g(rt.$$.fragment,t),g(ot.$$.fragment,t),g(it.$$.fragment,t),g(ft.$$.fragment,t),ie=!0)},o(t){m(j.$$.fragment,t),m(U.$$.fragment,t),m(W.$$.fragment,t),m(K.$$.fragment,t),m(Q.$$.fragment,t),m(tt.$$.fragment,t),m(at.$$.fragment,t),m(rt.$$.fragment,t),m(ot.$$.fragment,t),m(it.$$.fragment,t),m(ft.$$.fragment,t),ie=!1},d(t){t&&(e(It),e(T),e(Gt),e(z),e(Bt),e(J),e(Ft),e(S),e(qt),e(b),e(Dt),e(V),e(Ot),e(y),e(jt),e(Z),e(zt),e(P),e(Jt),e(X),e(Ut),e(A),e(Vt),e(Y),e(Wt),e($),e(Zt),e(et),e(Kt),e(_),e(Xt),e(dt),e(Qt),e(C),e(Yt),e(nt),e(te),e(L),e(ee),e(lt),e(ae),e(E),e(de),e(st),e(re),e(ht),e(ne),e(k),e(oe),e(pt),e(le),e(ut)),e(x),v(j),v(U),v(W),v(K),v(Q),v(tt),v(at),v(rt),v(ot),v(it),v(ft)}}}const Ha={local:"peft",sections:[{local:"supported-methods",title:"Supported methods"},{local:"supported-models",sections:[{local:"causal-language-modeling",title:"Causal Language Modeling"},{local:"conditional-generation",title:"Conditional Generation"},{local:"sequence-classification",title:"Sequence Classification"},{local:"token-classification",title:"Token Classification"},{local:"texttoimage-generation",title:"Text-to-Image Generation"},{local:"image-classification",title:"Image Classification"},{local:"image-to-text-multimodal-models",title:"Image to text (Multi-modal models)"},{local:"semantic-segmentation",title:"Semantic Segmentation"}],title:"Supported models"}],title:"PEFT"};function Na(Me){return La(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ba extends Ea{constructor(x){super(),ka(this,x,Na,Sa,_a,{})}}export{Ba as component};
