import{s as rt,n as at,o as it}from"../chunks/scheduler.c59d9fbb.js";import{S as st,i as ft,g as o,s as i,r as g,A as pt,h as r,f as t,c as s,j as p,u as h,x as m,k as a,y as n,a as l,v as u,d as _,t as v,w as y}from"../chunks/index.a47918e3.js";import{D as te}from"../chunks/Docstring.d228fbdd.js";import{I as Ce}from"../chunks/IconCopyLink.1678bef0.js";function lt(Oe){let b,ie,P,T,ne,D,we,R,ze="Configuration",se,j,Fe='The configuration classes stores the configuration of a <a href="/docs/peft/main/en/package_reference/peft_model#peft.PeftModel">PeftModel</a>, PEFT adapter models, and the configurations of <code>PrefixTuning</code>, <code>PromptTuning</code>, and <a href="/docs/peft/main/en/package_reference/tuners#peft.PromptEncoder">PromptEncoder</a>. They contain methods for saving and loading model configurations from the Hub, specifying the PEFT method to use, type of task to perform, and model configurations like number of layers and number of attention heads.',fe,$,M,oe,S,ke,W,Ue="PeftConfigMixin",pe,d,I,Te,B,Ve=`This is the base configuration class for PEFT adapter models. It contains all the methods that are common to all
PEFT adapter models. This class inherits from <a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.utils.PushToHubMixin" rel="nofollow">PushToHubMixin</a> which contains the methods to
push your model to the Hub. The method <code>save_pretrained</code> will save the configuration of your adapter model in a
directory. The method <code>from_pretrained</code> will load the configuration of your adapter model from a directory.`,Me,L,O,Le,G,qe="Loads a configuration file from a json file.",Ee,E,z,Ne,K,Je="This method loads the configuration of your adapter model from a directory.",He,N,F,Ae,Q,Re="This method saves the configuration of your adapter model in a directory.",le,x,H,re,U,De,X,We="PeftConfig",de,C,V,je,Y,Be='This is the base configuration class to store the configuration of a <a href="/docs/peft/main/en/package_reference/peft_model#peft.PeftModel">PeftModel</a>.',me,w,A,ae,q,Se,Z,Ge="PromptLearningConfig",ce,k,J,Ie,ee,Ke=`This is the base configuration class to store the configuration of <code>PrefixTuning</code>, <a href="/docs/peft/main/en/package_reference/tuners#peft.PromptEncoder">PromptEncoder</a>, or
<code>PromptTuning</code>.`,ge;return D=new Ce({}),S=new Ce({}),I=new te({props:{name:"class peft.config.PeftConfigMixin",anchor:"peft.config.PeftConfigMixin",parameters:[{name:"peft_type",val:": typing.Optional[peft.utils.peft_types.PeftType] = None"},{name:"auto_mapping",val:": typing.Optional[dict] = None"}],parametersDescription:[{anchor:"peft.config.PeftConfigMixin.peft_type",description:"<strong>peft_type</strong> (Union[<code>~peft.utils.config.PeftType</code>, <code>str</code>]) &#x2014; The type of Peft method to use.",name:"peft_type"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L28"}}),O=new te({props:{name:"from_json_file",anchor:"peft.config.PeftConfigMixin.from_json_file",parameters:[{name:"path_json_file",val:": str"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"peft.config.PeftConfigMixin.from_json_file.path_json_file",description:`<strong>path_json_file</strong> (<code>str</code>) &#x2014;
The path to the json file.`,name:"path_json_file"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L136"}}),z=new te({props:{name:"from_pretrained",anchor:"peft.config.PeftConfigMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": str"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"peft.config.PeftConfigMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code>) &#x2014;
The directory or the Hub repository id where the configuration is saved.`,name:"pretrained_model_name_or_path"},{anchor:"peft.config.PeftConfigMixin.from_pretrained.kwargs",description:`<strong>kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Additional keyword arguments passed along to the child class initialization.`,name:"kwargs"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L74"}}),F=new te({props:{name:"save_pretrained",anchor:"peft.config.PeftConfigMixin.save_pretrained",parameters:[{name:"save_directory",val:": str"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"peft.config.PeftConfigMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code>) &#x2014;
The directory where the configuration will be saved.`,name:"save_directory"},{anchor:"peft.config.PeftConfigMixin.save_pretrained.kwargs",description:`<strong>kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Additional keyword arguments passed along to the <a href="https://huggingface.co/docs/transformers/main/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.push_to_hub" rel="nofollow">push_to_hub</a>
method.`,name:"kwargs"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L46"}}),U=new Ce({}),V=new te({props:{name:"class peft.PeftConfig",anchor:"peft.PeftConfig",parameters:[{name:"peft_type",val:": typing.Union[str, peft.utils.peft_types.PeftType] = None"},{name:"auto_mapping",val:": typing.Optional[dict] = None"},{name:"base_model_name_or_path",val:": str = None"},{name:"revision",val:": str = None"},{name:"task_type",val:": typing.Union[str, peft.utils.peft_types.TaskType] = None"},{name:"inference_mode",val:": bool = False"}],parametersDescription:[{anchor:"peft.PeftConfig.peft_type",description:"<strong>peft_type</strong> (Union[<code>~peft.utils.config.PeftType</code>, <code>str</code>]) &#x2014; The type of Peft method to use.",name:"peft_type"},{anchor:"peft.PeftConfig.task_type",description:"<strong>task_type</strong> (Union[<code>~peft.utils.config.TaskType</code>, <code>str</code>]) &#x2014; The type of task to perform.",name:"task_type"},{anchor:"peft.PeftConfig.inference_mode",description:"<strong>inference_mode</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014; Whether to use the Peft model in inference mode.",name:"inference_mode"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L205"}}),q=new Ce({}),J=new te({props:{name:"class peft.PromptLearningConfig",anchor:"peft.PromptLearningConfig",parameters:[{name:"peft_type",val:": typing.Union[str, peft.utils.peft_types.PeftType] = None"},{name:"auto_mapping",val:": typing.Optional[dict] = None"},{name:"base_model_name_or_path",val:": str = None"},{name:"revision",val:": str = None"},{name:"task_type",val:": typing.Union[str, peft.utils.peft_types.TaskType] = None"},{name:"inference_mode",val:": bool = False"},{name:"num_virtual_tokens",val:": int = None"},{name:"token_dim",val:": int = None"},{name:"num_transformer_submodules",val:": typing.Optional[int] = None"},{name:"num_attention_heads",val:": typing.Optional[int] = None"},{name:"num_layers",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"peft.PromptLearningConfig.num_virtual_tokens",description:"<strong>num_virtual_tokens</strong> (<code>int</code>) &#x2014; The number of virtual tokens to use.",name:"num_virtual_tokens"},{anchor:"peft.PromptLearningConfig.token_dim",description:"<strong>token_dim</strong> (<code>int</code>) &#x2014; The hidden embedding dimension of the base transformer model.",name:"token_dim"},{anchor:"peft.PromptLearningConfig.num_transformer_submodules",description:"<strong>num_transformer_submodules</strong> (<code>int</code>) &#x2014; The number of transformer submodules in the base transformer model.",name:"num_transformer_submodules"},{anchor:"peft.PromptLearningConfig.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>) &#x2014; The number of attention heads in the base transformer model.",name:"num_attention_heads"},{anchor:"peft.PromptLearningConfig.num_layers",description:"<strong>num_layers</strong> (<code>int</code>) &#x2014; The number of layers in the base transformer model.",name:"num_layers"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/config.py#L223"}}),{c(){b=o("meta"),ie=i(),P=o("h1"),T=o("a"),ne=o("span"),g(D.$$.fragment),we=i(),R=o("span"),R.textContent=ze,se=i(),j=o("p"),j.innerHTML=Fe,fe=i(),$=o("h2"),M=o("a"),oe=o("span"),g(S.$$.fragment),ke=i(),W=o("span"),W.textContent=Ue,pe=i(),d=o("div"),g(I.$$.fragment),Te=i(),B=o("p"),B.innerHTML=Ve,Me=i(),L=o("div"),g(O.$$.fragment),Le=i(),G=o("p"),G.textContent=qe,Ee=i(),E=o("div"),g(z.$$.fragment),Ne=i(),K=o("p"),K.textContent=Je,He=i(),N=o("div"),g(F.$$.fragment),Ae=i(),Q=o("p"),Q.textContent=Re,le=i(),x=o("h2"),H=o("a"),re=o("span"),g(U.$$.fragment),De=i(),X=o("span"),X.textContent=We,de=i(),C=o("div"),g(V.$$.fragment),je=i(),Y=o("p"),Y.innerHTML=Be,me=i(),w=o("h2"),A=o("a"),ae=o("span"),g(q.$$.fragment),Se=i(),Z=o("span"),Z.textContent=Ge,ce=i(),k=o("div"),g(J.$$.fragment),Ie=i(),ee=o("p"),ee.innerHTML=Ke,this.h()},l(e){const f=pt("svelte-1phssyn",document.head);b=r(f,"META",{name:!0,content:!0}),f.forEach(t),ie=s(e),P=r(e,"H1",{class:!0});var he=p(P);T=r(he,"A",{id:!0,class:!0,href:!0});var Qe=p(T);ne=r(Qe,"SPAN",{});var Xe=p(ne);h(D.$$.fragment,Xe),Xe.forEach(t),Qe.forEach(t),we=s(he),R=r(he,"SPAN",{"data-svelte-h":!0}),m(R)!=="svelte-13rze9p"&&(R.textContent=ze),he.forEach(t),se=s(e),j=r(e,"P",{"data-svelte-h":!0}),m(j)!=="svelte-1dkzixn"&&(j.innerHTML=Fe),fe=s(e),$=r(e,"H2",{class:!0});var ue=p($);M=r(ue,"A",{id:!0,class:!0,href:!0});var Ye=p(M);oe=r(Ye,"SPAN",{});var Ze=p(oe);h(S.$$.fragment,Ze),Ze.forEach(t),Ye.forEach(t),ke=s(ue),W=r(ue,"SPAN",{"data-svelte-h":!0}),m(W)!=="svelte-1mjq6av"&&(W.textContent=Ue),ue.forEach(t),pe=s(e),d=r(e,"DIV",{class:!0});var c=p(d);h(I.$$.fragment,c),Te=s(c),B=r(c,"P",{"data-svelte-h":!0}),m(B)!=="svelte-1mh9vl"&&(B.innerHTML=Ve),Me=s(c),L=r(c,"DIV",{class:!0});var _e=p(L);h(O.$$.fragment,_e),Le=s(_e),G=r(_e,"P",{"data-svelte-h":!0}),m(G)!=="svelte-zcd40r"&&(G.textContent=qe),_e.forEach(t),Ee=s(c),E=r(c,"DIV",{class:!0});var ve=p(E);h(z.$$.fragment,ve),Ne=s(ve),K=r(ve,"P",{"data-svelte-h":!0}),m(K)!=="svelte-z7yz95"&&(K.textContent=Je),ve.forEach(t),He=s(c),N=r(c,"DIV",{class:!0});var ye=p(N);h(F.$$.fragment,ye),Ae=s(ye),Q=r(ye,"P",{"data-svelte-h":!0}),m(Q)!=="svelte-fhg9sv"&&(Q.textContent=Re),ye.forEach(t),c.forEach(t),le=s(e),x=r(e,"H2",{class:!0});var be=p(x);H=r(be,"A",{id:!0,class:!0,href:!0});var et=p(H);re=r(et,"SPAN",{});var tt=p(re);h(U.$$.fragment,tt),tt.forEach(t),et.forEach(t),De=s(be),X=r(be,"SPAN",{"data-svelte-h":!0}),m(X)!=="svelte-u4x9xc"&&(X.textContent=We),be.forEach(t),de=s(e),C=r(e,"DIV",{class:!0});var Pe=p(C);h(V.$$.fragment,Pe),je=s(Pe),Y=r(Pe,"P",{"data-svelte-h":!0}),m(Y)!=="svelte-1r1kq2j"&&(Y.innerHTML=Be),Pe.forEach(t),me=s(e),w=r(e,"H2",{class:!0});var $e=p(w);A=r($e,"A",{id:!0,class:!0,href:!0});var nt=p(A);ae=r(nt,"SPAN",{});var ot=p(ae);h(q.$$.fragment,ot),ot.forEach(t),nt.forEach(t),Se=s($e),Z=r($e,"SPAN",{"data-svelte-h":!0}),m(Z)!=="svelte-fisyab"&&(Z.textContent=Ge),$e.forEach(t),ce=s(e),k=r(e,"DIV",{class:!0});var xe=p(k);h(J.$$.fragment,xe),Ie=s(xe),ee=r(xe,"P",{"data-svelte-h":!0}),m(ee)!=="svelte-aw9f3p"&&(ee.innerHTML=Ke),xe.forEach(t),this.h()},h(){a(b,"name","hf:doc:metadata"),a(b,"content",JSON.stringify(dt)),a(T,"id","configuration"),a(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(T,"href","#configuration"),a(P,"class","relative group"),a(M,"id","peft.config.PeftConfigMixin"),a(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(M,"href","#peft.config.PeftConfigMixin"),a($,"class","relative group"),a(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(H,"id","peft.PeftConfig"),a(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(H,"href","#peft.PeftConfig"),a(x,"class","relative group"),a(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(A,"id","peft.PromptLearningConfig"),a(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(A,"href","#peft.PromptLearningConfig"),a(w,"class","relative group"),a(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,f){n(document.head,b),l(e,ie,f),l(e,P,f),n(P,T),n(T,ne),u(D,ne,null),n(P,we),n(P,R),l(e,se,f),l(e,j,f),l(e,fe,f),l(e,$,f),n($,M),n(M,oe),u(S,oe,null),n($,ke),n($,W),l(e,pe,f),l(e,d,f),u(I,d,null),n(d,Te),n(d,B),n(d,Me),n(d,L),u(O,L,null),n(L,Le),n(L,G),n(d,Ee),n(d,E),u(z,E,null),n(E,Ne),n(E,K),n(d,He),n(d,N),u(F,N,null),n(N,Ae),n(N,Q),l(e,le,f),l(e,x,f),n(x,H),n(H,re),u(U,re,null),n(x,De),n(x,X),l(e,de,f),l(e,C,f),u(V,C,null),n(C,je),n(C,Y),l(e,me,f),l(e,w,f),n(w,A),n(A,ae),u(q,ae,null),n(w,Se),n(w,Z),l(e,ce,f),l(e,k,f),u(J,k,null),n(k,Ie),n(k,ee),ge=!0},p:at,i(e){ge||(_(D.$$.fragment,e),_(S.$$.fragment,e),_(I.$$.fragment,e),_(O.$$.fragment,e),_(z.$$.fragment,e),_(F.$$.fragment,e),_(U.$$.fragment,e),_(V.$$.fragment,e),_(q.$$.fragment,e),_(J.$$.fragment,e),ge=!0)},o(e){v(D.$$.fragment,e),v(S.$$.fragment,e),v(I.$$.fragment,e),v(O.$$.fragment,e),v(z.$$.fragment,e),v(F.$$.fragment,e),v(U.$$.fragment,e),v(V.$$.fragment,e),v(q.$$.fragment,e),v(J.$$.fragment,e),ge=!1},d(e){e&&(t(ie),t(P),t(se),t(j),t(fe),t($),t(pe),t(d),t(le),t(x),t(de),t(C),t(me),t(w),t(ce),t(k)),t(b),y(D),y(S),y(I),y(O),y(z),y(F),y(U),y(V),y(q),y(J)}}}const dt={local:"configuration",sections:[{local:"peft.config.PeftConfigMixin",title:"PeftConfigMixin"},{local:"peft.PeftConfig",title:"PeftConfig"},{local:"peft.PromptLearningConfig",title:"PromptLearningConfig"}],title:"Configuration"};function mt(Oe){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _t extends st{constructor(b){super(),ft(this,b,mt,lt,rt,{})}}export{_t as component};
