import{s as gn,n as wn,o as xn}from"../chunks/scheduler.c59d9fbb.js";import{S as yn,i as bn,g as a,s as l,r as d,A as Cn,h as i,f as t,c as s,j as p,u as f,x as r,k as h,y as u,a as o,v as c,d as m,t as v,w as g}from"../chunks/index.a47918e3.js";import{I as fe}from"../chunks/IconCopyLink.1678bef0.js";import{C as $t}from"../chunks/CodeBlock.8292b900.js";function $n(kt){let w,Me,x,P,be,q,vt,ce,_t="Contributing to PEFT",Te,R,Pt="We are happy to accept contributions to PEFT. If you plan to contribute, please read this document to make the process as smooth as possible.",Ee,y,A,Ce,S,gt,me,At="Installation",He,I,Mt='The installation instructions can be found <a href="https://huggingface.co/docs/peft/install" rel="nofollow">here</a>. If you want to provide code contributions to PEFT, you should choose the “source” installation method.',je,N,Tt='If you are new to creating a pull request, follow <a href="https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/proposing-changes-to-your-work-with-pull-requests/creating-a-pull-request" rel="nofollow">these instructions from GitHub</a>.',qe,b,M,$e,L,wt,ve,Et="Running tests and code quality checks",Re,F,Ht="Regardless of the type of contribution (unless it’s only about the docs), you should run tests and code quality checks before creating a PR to ensure that your contribution doesn’t break anything and follows the standards of the project.",Se,W,jt="We provide a Makefile to facilitate those steps. Run the code below for the unit test:",Ie,z,Ne,U,qt="Run one of the following to either check or check and fix code quality and style:",Le,G,Fe,Y,Rt="Running all the tests can take a couple of minutes. Therefore, during development, it can be useful to run only those tests specific to your change:",We,B,ze,Z,St="This should finish much quicker and allow faster iteration. Before creating the PR, however, please still run the whole test suite, as some changes can inadvertently break tests that at first glance are unrelated.",Ue,J,It="If your change is specific to a hardware setting (e.g. it requires CUDA), take a look at <code>tests/test_gpu_examples.py</code> and <code>tests/test_common_gpu.py</code> – maybe it makes sense to add a test there.",Ge,O,Nt="It can happen that while you’re working on your PR, the underlying code base changes due to other changes being merged. If that happens – especially when there is a merge conflict – please update your branch to be on the latest changes. This can be a merge or a rebase, whatever you prefer. We will squash and merge the PR once it’s ready.",Ye,C,T,ke,Q,xt,ge,Lt="PR description",Be,V,Ft="When opening the PR, please provide a nice description of the change you provide. If it relates to other issues or PRs, please reference them. Providing a good description will not only help the reviewers review your code better and faster, it can also later be used (as a basis) for the commit message, which helps with long term maintenance of the project.",Ze,D,Wt="If your code makes some non-trivial changes, it can also be a good idea to add comments to the code to explain those changes. For example, if you had to iterate on your implementation multiple times because the most obvious way didn’t work, it’s a good indication that a code comment is needed.",Je,$,E,_e,X,yt,we,zt="Providing a bugfix",Oe,K,Ut="Please give a description of the circumstances that lead to the bug. If there is an existing issue, please link to it (e.g. “Resolves #12345”).",Qe,ee,Gt="Ideally, when a bugfix is provided, it should be accompanied by a test for this bug. The test should fail with the current code and pass with the bugfix. Add a comment to the test that references the issue or PR. Without such a test, it is difficult to prevent regressions in the future.",Ve,k,H,Pe,te,bt,xe,Yt="Adding a new fine-tuning method",De,ne,Bt="New parameter-efficient fine-tuning methods are developed all the time. If you would like to add a new, promising method to PEFT, please follow these steps.",Xe,oe,Zt="<strong>Requirements</strong>",Ke,ae,Jt="<li>Please add a link to the source (usually a paper) of the method.</li> <li>Some evidence should be provided that there is general interest in using the method. We will not add new methods that are freshly published but without evidence that there is demand for it.</li> <li>Ideally, we want to not only add the implementation of the new method, but also examples (notebooks, scripts), documentation, and an extensive test suite that proves that the method works with a variety of tasks. However, this can be very daunting. Therefore, it is also acceptable to only provide the implementation and at least one working example. Documentation and tests can be added in follow up PRs.</li>",et,ie,Ot="<strong>Steps</strong>",tt,le,Qt="Before you start to implement the new method, please open an issue on GitHub with your proposal. That way, the maintainers can give you some early feedback.",nt,se,Vt="When implementing the method, it makes sense to look for existing implementations that already exist as a guide. Moreover, when you structure your code, please take inspiration from the other PEFT methods. For example, if your method is similar to LoRA, it makes sense to structure your code similarly or even re-use some functions or classes where it makes sense (but don’t overdo it, some code duplication is okay).",ot,re,Dt="Once you have something that seems to be working, don’t hesitate to create a draft PR, even if it’s not in a mergeable state yet. The maintainers will be happy to give you feedback and guidance along the way.",at,_,j,Ae,he,Ct,ye,Xt="Adding other features",it,ue,Kt="It is best if you first open an issue on GitHub with a proposal to add the new feature. That way, you can discuss with the maintainers if it makes sense to add the feature before spending too much time on implementing it.",lt,pe,en="New features should generally be accompanied by tests and documentation or examples. Without the latter, users will have a hard time discovering your cool new feature.",st,de,tn="Changes to the code should be implemented in a backward-compatible way. For example, existing code should continue to work the same way after the feature is merged.",rt;return q=new fe({}),S=new fe({}),L=new fe({}),z=new $t({props:{code:"bWFrZSUyMHRlc3Q=",highlighted:'make <span class="hljs-built_in">test</span>'}}),G=new $t({props:{code:"bWFrZSUyMHF1YWxpdHklMjAlMjAlMjMlMjBqdXN0JTIwY2hlY2slMEFtYWtlJTIwc3R5bGUlMjAlMjAlMjMlMjBjaGVjayUyMGFuZCUyMGZpeA==",highlighted:`make quality  <span class="hljs-comment"># just check</span>
make style  <span class="hljs-comment"># check and fix</span>`}}),B=new $t({props:{code:"cHl0ZXN0JTIwdGVzdHMlMkYlMjAtayUyMCUzQ25hbWUtb2YtdGVzdCUzRQ==",highlighted:"pytest tests/ -k &lt;name-of-test&gt;"}}),Q=new fe({}),X=new fe({}),te=new fe({}),he=new fe({}),{c(){w=a("meta"),Me=l(),x=a("h1"),P=a("a"),be=a("span"),d(q.$$.fragment),vt=l(),ce=a("span"),ce.textContent=_t,Te=l(),R=a("p"),R.textContent=Pt,Ee=l(),y=a("h2"),A=a("a"),Ce=a("span"),d(S.$$.fragment),gt=l(),me=a("span"),me.textContent=At,He=l(),I=a("p"),I.innerHTML=Mt,je=l(),N=a("p"),N.innerHTML=Tt,qe=l(),b=a("h2"),M=a("a"),$e=a("span"),d(L.$$.fragment),wt=l(),ve=a("span"),ve.textContent=Et,Re=l(),F=a("p"),F.textContent=Ht,Se=l(),W=a("p"),W.textContent=jt,Ie=l(),d(z.$$.fragment),Ne=l(),U=a("p"),U.textContent=qt,Le=l(),d(G.$$.fragment),Fe=l(),Y=a("p"),Y.textContent=Rt,We=l(),d(B.$$.fragment),ze=l(),Z=a("p"),Z.textContent=St,Ue=l(),J=a("p"),J.innerHTML=It,Ge=l(),O=a("p"),O.textContent=Nt,Ye=l(),C=a("h2"),T=a("a"),ke=a("span"),d(Q.$$.fragment),xt=l(),ge=a("span"),ge.textContent=Lt,Be=l(),V=a("p"),V.textContent=Ft,Ze=l(),D=a("p"),D.textContent=Wt,Je=l(),$=a("h2"),E=a("a"),_e=a("span"),d(X.$$.fragment),yt=l(),we=a("span"),we.textContent=zt,Oe=l(),K=a("p"),K.textContent=Ut,Qe=l(),ee=a("p"),ee.textContent=Gt,Ve=l(),k=a("h2"),H=a("a"),Pe=a("span"),d(te.$$.fragment),bt=l(),xe=a("span"),xe.textContent=Yt,De=l(),ne=a("p"),ne.textContent=Bt,Xe=l(),oe=a("p"),oe.innerHTML=Zt,Ke=l(),ae=a("ol"),ae.innerHTML=Jt,et=l(),ie=a("p"),ie.innerHTML=Ot,tt=l(),le=a("p"),le.textContent=Qt,nt=l(),se=a("p"),se.textContent=Vt,ot=l(),re=a("p"),re.textContent=Dt,at=l(),_=a("h2"),j=a("a"),Ae=a("span"),d(he.$$.fragment),Ct=l(),ye=a("span"),ye.textContent=Xt,it=l(),ue=a("p"),ue.textContent=Kt,lt=l(),pe=a("p"),pe.textContent=en,st=l(),de=a("p"),de.textContent=tn,this.h()},l(e){const n=Cn("svelte-1phssyn",document.head);w=i(n,"META",{name:!0,content:!0}),n.forEach(t),Me=s(e),x=i(e,"H1",{class:!0});var ht=p(x);P=i(ht,"A",{id:!0,class:!0,href:!0});var nn=p(P);be=i(nn,"SPAN",{});var on=p(be);f(q.$$.fragment,on),on.forEach(t),nn.forEach(t),vt=s(ht),ce=i(ht,"SPAN",{"data-svelte-h":!0}),r(ce)!=="svelte-1ygwn8f"&&(ce.textContent=_t),ht.forEach(t),Te=s(e),R=i(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1c6ygqi"&&(R.textContent=Pt),Ee=s(e),y=i(e,"H2",{class:!0});var ut=p(y);A=i(ut,"A",{id:!0,class:!0,href:!0});var an=p(A);Ce=i(an,"SPAN",{});var ln=p(Ce);f(S.$$.fragment,ln),ln.forEach(t),an.forEach(t),gt=s(ut),me=i(ut,"SPAN",{"data-svelte-h":!0}),r(me)!=="svelte-99g31l"&&(me.textContent=At),ut.forEach(t),He=s(e),I=i(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-rfhs4a"&&(I.innerHTML=Mt),je=s(e),N=i(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-ws2zjr"&&(N.innerHTML=Tt),qe=s(e),b=i(e,"H2",{class:!0});var pt=p(b);M=i(pt,"A",{id:!0,class:!0,href:!0});var sn=p(M);$e=i(sn,"SPAN",{});var rn=p($e);f(L.$$.fragment,rn),rn.forEach(t),sn.forEach(t),wt=s(pt),ve=i(pt,"SPAN",{"data-svelte-h":!0}),r(ve)!=="svelte-1g71xrx"&&(ve.textContent=Et),pt.forEach(t),Re=s(e),F=i(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-11t0ric"&&(F.textContent=Ht),Se=s(e),W=i(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-160fet5"&&(W.textContent=jt),Ie=s(e),f(z.$$.fragment,e),Ne=s(e),U=i(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1l46aqt"&&(U.textContent=qt),Le=s(e),f(G.$$.fragment,e),Fe=s(e),Y=i(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1opmzsc"&&(Y.textContent=Rt),We=s(e),f(B.$$.fragment,e),ze=s(e),Z=i(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-6q0ait"&&(Z.textContent=St),Ue=s(e),J=i(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-15mrc92"&&(J.innerHTML=It),Ge=s(e),O=i(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1a7yicx"&&(O.textContent=Nt),Ye=s(e),C=i(e,"H2",{class:!0});var dt=p(C);T=i(dt,"A",{id:!0,class:!0,href:!0});var hn=p(T);ke=i(hn,"SPAN",{});var un=p(ke);f(Q.$$.fragment,un),un.forEach(t),hn.forEach(t),xt=s(dt),ge=i(dt,"SPAN",{"data-svelte-h":!0}),r(ge)!=="svelte-ja8r4l"&&(ge.textContent=Lt),dt.forEach(t),Be=s(e),V=i(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-14z5ffc"&&(V.textContent=Ft),Ze=s(e),D=i(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1in0ysn"&&(D.textContent=Wt),Je=s(e),$=i(e,"H2",{class:!0});var ft=p($);E=i(ft,"A",{id:!0,class:!0,href:!0});var pn=p(E);_e=i(pn,"SPAN",{});var dn=p(_e);f(X.$$.fragment,dn),dn.forEach(t),pn.forEach(t),yt=s(ft),we=i(ft,"SPAN",{"data-svelte-h":!0}),r(we)!=="svelte-mvh20z"&&(we.textContent=zt),ft.forEach(t),Oe=s(e),K=i(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-9x9ukk"&&(K.textContent=Ut),Qe=s(e),ee=i(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-198yfji"&&(ee.textContent=Gt),Ve=s(e),k=i(e,"H2",{class:!0});var ct=p(k);H=i(ct,"A",{id:!0,class:!0,href:!0});var fn=p(H);Pe=i(fn,"SPAN",{});var cn=p(Pe);f(te.$$.fragment,cn),cn.forEach(t),fn.forEach(t),bt=s(ct),xe=i(ct,"SPAN",{"data-svelte-h":!0}),r(xe)!=="svelte-1x4t360"&&(xe.textContent=Yt),ct.forEach(t),De=s(e),ne=i(e,"P",{"data-svelte-h":!0}),r(ne)!=="svelte-va6j7r"&&(ne.textContent=Bt),Xe=s(e),oe=i(e,"P",{"data-svelte-h":!0}),r(oe)!=="svelte-ioylk5"&&(oe.innerHTML=Zt),Ke=s(e),ae=i(e,"OL",{"data-svelte-h":!0}),r(ae)!=="svelte-1dzjbe2"&&(ae.innerHTML=Jt),et=s(e),ie=i(e,"P",{"data-svelte-h":!0}),r(ie)!=="svelte-r3je5e"&&(ie.innerHTML=Ot),tt=s(e),le=i(e,"P",{"data-svelte-h":!0}),r(le)!=="svelte-1q528xb"&&(le.textContent=Qt),nt=s(e),se=i(e,"P",{"data-svelte-h":!0}),r(se)!=="svelte-1ep9htz"&&(se.textContent=Vt),ot=s(e),re=i(e,"P",{"data-svelte-h":!0}),r(re)!=="svelte-emkub4"&&(re.textContent=Dt),at=s(e),_=i(e,"H2",{class:!0});var mt=p(_);j=i(mt,"A",{id:!0,class:!0,href:!0});var mn=p(j);Ae=i(mn,"SPAN",{});var vn=p(Ae);f(he.$$.fragment,vn),vn.forEach(t),mn.forEach(t),Ct=s(mt),ye=i(mt,"SPAN",{"data-svelte-h":!0}),r(ye)!=="svelte-1ibzsth"&&(ye.textContent=Xt),mt.forEach(t),it=s(e),ue=i(e,"P",{"data-svelte-h":!0}),r(ue)!=="svelte-12p8h4o"&&(ue.textContent=Kt),lt=s(e),pe=i(e,"P",{"data-svelte-h":!0}),r(pe)!=="svelte-130om8q"&&(pe.textContent=en),st=s(e),de=i(e,"P",{"data-svelte-h":!0}),r(de)!=="svelte-1t6cuxz"&&(de.textContent=tn),this.h()},h(){h(w,"name","hf:doc:metadata"),h(w,"content",JSON.stringify(kn)),h(P,"id","contributing-to-peft"),h(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(P,"href","#contributing-to-peft"),h(x,"class","relative group"),h(A,"id","installation"),h(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(A,"href","#installation"),h(y,"class","relative group"),h(M,"id","running-tests-and-code-quality-checks"),h(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(M,"href","#running-tests-and-code-quality-checks"),h(b,"class","relative group"),h(T,"id","pr-description"),h(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(T,"href","#pr-description"),h(C,"class","relative group"),h(E,"id","providing-a-bugfix"),h(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(E,"href","#providing-a-bugfix"),h($,"class","relative group"),h(H,"id","adding-a-new-finetuning-method"),h(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(H,"href","#adding-a-new-finetuning-method"),h(k,"class","relative group"),h(j,"id","adding-other-features"),h(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(j,"href","#adding-other-features"),h(_,"class","relative group")},m(e,n){u(document.head,w),o(e,Me,n),o(e,x,n),u(x,P),u(P,be),c(q,be,null),u(x,vt),u(x,ce),o(e,Te,n),o(e,R,n),o(e,Ee,n),o(e,y,n),u(y,A),u(A,Ce),c(S,Ce,null),u(y,gt),u(y,me),o(e,He,n),o(e,I,n),o(e,je,n),o(e,N,n),o(e,qe,n),o(e,b,n),u(b,M),u(M,$e),c(L,$e,null),u(b,wt),u(b,ve),o(e,Re,n),o(e,F,n),o(e,Se,n),o(e,W,n),o(e,Ie,n),c(z,e,n),o(e,Ne,n),o(e,U,n),o(e,Le,n),c(G,e,n),o(e,Fe,n),o(e,Y,n),o(e,We,n),c(B,e,n),o(e,ze,n),o(e,Z,n),o(e,Ue,n),o(e,J,n),o(e,Ge,n),o(e,O,n),o(e,Ye,n),o(e,C,n),u(C,T),u(T,ke),c(Q,ke,null),u(C,xt),u(C,ge),o(e,Be,n),o(e,V,n),o(e,Ze,n),o(e,D,n),o(e,Je,n),o(e,$,n),u($,E),u(E,_e),c(X,_e,null),u($,yt),u($,we),o(e,Oe,n),o(e,K,n),o(e,Qe,n),o(e,ee,n),o(e,Ve,n),o(e,k,n),u(k,H),u(H,Pe),c(te,Pe,null),u(k,bt),u(k,xe),o(e,De,n),o(e,ne,n),o(e,Xe,n),o(e,oe,n),o(e,Ke,n),o(e,ae,n),o(e,et,n),o(e,ie,n),o(e,tt,n),o(e,le,n),o(e,nt,n),o(e,se,n),o(e,ot,n),o(e,re,n),o(e,at,n),o(e,_,n),u(_,j),u(j,Ae),c(he,Ae,null),u(_,Ct),u(_,ye),o(e,it,n),o(e,ue,n),o(e,lt,n),o(e,pe,n),o(e,st,n),o(e,de,n),rt=!0},p:wn,i(e){rt||(m(q.$$.fragment,e),m(S.$$.fragment,e),m(L.$$.fragment,e),m(z.$$.fragment,e),m(G.$$.fragment,e),m(B.$$.fragment,e),m(Q.$$.fragment,e),m(X.$$.fragment,e),m(te.$$.fragment,e),m(he.$$.fragment,e),rt=!0)},o(e){v(q.$$.fragment,e),v(S.$$.fragment,e),v(L.$$.fragment,e),v(z.$$.fragment,e),v(G.$$.fragment,e),v(B.$$.fragment,e),v(Q.$$.fragment,e),v(X.$$.fragment,e),v(te.$$.fragment,e),v(he.$$.fragment,e),rt=!1},d(e){e&&(t(Me),t(x),t(Te),t(R),t(Ee),t(y),t(He),t(I),t(je),t(N),t(qe),t(b),t(Re),t(F),t(Se),t(W),t(Ie),t(Ne),t(U),t(Le),t(Fe),t(Y),t(We),t(ze),t(Z),t(Ue),t(J),t(Ge),t(O),t(Ye),t(C),t(Be),t(V),t(Ze),t(D),t(Je),t($),t(Oe),t(K),t(Qe),t(ee),t(Ve),t(k),t(De),t(ne),t(Xe),t(oe),t(Ke),t(ae),t(et),t(ie),t(tt),t(le),t(nt),t(se),t(ot),t(re),t(at),t(_),t(it),t(ue),t(lt),t(pe),t(st),t(de)),t(w),g(q),g(S),g(L),g(z,e),g(G,e),g(B,e),g(Q),g(X),g(te),g(he)}}}const kn={local:"contributing-to-peft",sections:[{local:"installation",title:"Installation"},{local:"running-tests-and-code-quality-checks",title:"Running tests and code quality checks"},{local:"pr-description",title:"PR description"},{local:"providing-a-bugfix",title:"Providing a bugfix"},{local:"adding-a-new-finetuning-method",title:"Adding a new fine-tuning method"},{local:"adding-other-features",title:"Adding other features"}],title:"Contributing to PEFT"};function _n(kt){return xn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class En extends yn{constructor(w){super(),bn(this,w,_n,$n,gn,{})}}export{En as component};
